<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="robots" content="noodp" />
        <title>Bulk Delete Cloudflare DNS Records - AB Engineering Blog</title><meta name="description" content="Cloudflare doesn&#39;t let you bulk delete in the UI. In this blog, we show you how to use Python script to bulk delete DNS records in Cloudflare."><meta property="og:title" content="Bulk Delete Cloudflare DNS Records" />
<meta property="og:description" content="Cloudflare doesn&#39;t let you bulk delete in the UI. In this blog, we show you how to use Python script to bulk delete DNS records in Cloudflare." />
<meta property="og:type" content="article" />
<meta property="og:url" content="https://blog.alphabravo.io/posts/2021/bulk-delete-clouflare-dns/" /><meta property="og:image" content="https://blog.alphabravo.io/assets/2021/12/bulk-delete-cf-social.png" /><meta property="article:section" content="posts" />
<meta property="article:published_time" content="2021-12-23T13:00:00+00:00" />
<meta property="article:modified_time" content="2021-12-23T13:00:00+00:00" />

<meta name="twitter:card" content="summary_large_image"/>
<meta name="twitter:image" content="https://blog.alphabravo.io/assets/2021/12/bulk-delete-cf-social.png"/>

<meta name="twitter:title" content="Bulk Delete Cloudflare DNS Records"/>
<meta name="twitter:description" content="Cloudflare doesn&#39;t let you bulk delete in the UI. In this blog, we show you how to use Python script to bulk delete DNS records in Cloudflare."/>
<meta name="application-name" content="AB Engineering Blog">
<meta name="apple-mobile-web-app-title" content="AB Engineering Blog"><link rel="shortcut icon" type="image/x-icon" href="/favicon.ico" />
        <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
        <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png"><link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png"><link rel="manifest" href="/site.webmanifest"><link rel="canonical" href="https://blog.alphabravo.io/posts/2021/bulk-delete-clouflare-dns/" /><link rel="prev" href="https://blog.alphabravo.io/posts/2021/zero-to-hero-working-with-multiple-kubeconfig/" /><link rel="stylesheet" href="/css/page.min.css"><link rel="stylesheet" href="/css/home.min.css"><script type="application/ld+json">
    {
        "@context": "http://schema.org",
        "@type": "BlogPosting",
        "headline": "Bulk Delete Cloudflare DNS Records",
        "inLanguage": "en",
        "mainEntityOfPage": {
            "@type": "WebPage",
            "@id": "https:\/\/blog.alphabravo.io\/posts\/2021\/bulk-delete-clouflare-dns\/"
        },"image": ["https:\/\/blog.alphabravo.io\/assets\/2021\/12\/bulk-delete-cf-social.png"],"genre": "posts","keywords": "cloudflare, dns","wordcount":  551 ,
        "url": "https:\/\/blog.alphabravo.io\/posts\/2021\/bulk-delete-clouflare-dns\/","datePublished": "2021-12-23T13:00:00+00:00","dateModified": "2021-12-23T13:00:00+00:00","publisher": {
            "@type": "Organization",
            "name": "AlphaBravo","logo": "https:\/\/blog.alphabravo.io\/assets\/alphabravo-logoonly-outline1.png"},"author": {
                "@type": "Person",
                "name": "Mike 'MJ' Johnson"
            },"description": "Cloudflare doesn't let you bulk delete in the UI. In this blog, we show you how to use Python script to bulk delete DNS records in Cloudflare."
    }
    </script></head><body data-header-desktop="auto" data-header-mobile="auto"><script>(window.localStorage && localStorage.getItem('theme') ? localStorage.getItem('theme') === 'dark' : ('' === 'auto' ? window.matchMedia('(prefers-color-scheme: dark)').matches : '' === 'dark')) && document.body.setAttribute('theme', 'dark');</script>

        <div id="mask"></div><div class="wrapper"><header class="desktop" id="header-desktop">
    <div class="header-wrapper">
        <div class="header-title">
            <a href="/" title="AB Engineering Blog"><img
        class="lazyload logo"
        src="/svg/loading.min.svg"
        data-src="/assets/alphabravo-logoonly-outline1.png"
        data-srcset="/assets/alphabravo-logoonly-outline1.png, /assets/alphabravo-logoonly-outline1.png 1.5x, /assets/alphabravo-logoonly-outline1.png 2x"
        data-sizes="auto"
        alt="/assets/alphabravo-logoonly-outline1.png"
        title="/assets/alphabravo-logoonly-outline1.png" /><span id="id-1" class="typeit"></span></a>
        </div>
        <div class="menu">
            <div class="menu-inner"><a class="menu-item" href="/" title="Blog Homepage"> Home </a><a class="menu-item" href="https://alphabravo.io" title="AlphaBravo Website" rel="noopener noreffer" target="_blank"> AB Website </a><a class="menu-item" href="/posts/"> Posts </a><a class="menu-item" href="https://github.com/AlphaBravoCompany" rel="noopener noreffer" target="_blank"><i class='fab fa-github fa-fw'></i>  </a><a class="menu-item" href="https://linkedin.com/company/alphabravogov/" rel="noopener noreffer" target="_blank"><i class='fab fa-linkedin fa-fw'></i>  </a><span class="menu-item delimiter"></span><span class="menu-item search" id="search-desktop">
                        <input type="text" placeholder="Search" id="search-input-desktop">
                        <a href="#" class="search-button search-toggle" id="search-toggle-desktop" title="Search">
                            <i class="fas fa-search fa-fw"></i>
                        </a>
                        <a href="#" class="search-button search-clear" id="search-clear-desktop" title="Clear">
                            <i class="fas fa-times-circle fa-fw"></i>
                        </a>
                        <span class="search-button search-loading" id="search-loading-desktop">
                            <i class="fas fa-spinner fa-fw fa-spin"></i>
                        </span>
                    </span><a class="menu-item" href="/index.xml" title="RSS"><i class="fas fa-rss fa-fw" title="RSS"></i> </a><a href="javascript:void(0);" class="menu-item theme-switch" title="Switch Theme">
                    <i class="fas fa-adjust fa-fw"></i>
                </a>
            </div>
        </div>
    </div>
</header><header class="mobile" id="header-mobile">
    <div class="header-container">
        <div class="header-wrapper">
            <div class="header-title">
                <a href="/" title="AB Engineering Blog"><img
        class="lazyload logo"
        src="/svg/loading.min.svg"
        data-src="/assets/alphabravo-logoonly-outline1.png"
        data-srcset="/assets/alphabravo-logoonly-outline1.png, /assets/alphabravo-logoonly-outline1.png 1.5x, /assets/alphabravo-logoonly-outline1.png 2x"
        data-sizes="auto"
        alt="/assets/alphabravo-logoonly-outline1.png"
        title="/assets/alphabravo-logoonly-outline1.png" /><span id="id-2" class="typeit"></span></a>
            </div>
            <div class="menu-toggle" id="menu-toggle-mobile">
                <span></span><span></span><span></span>
            </div>
        </div>
        <div class="menu" id="menu-mobile"><div class="search-wrapper">
                    <div class="search mobile" id="search-mobile">
                        <input type="text" placeholder="Search" id="search-input-mobile">
                        <a href="#" class="search-button search-toggle" id="search-toggle-mobile" title="Search">
                            <i class="fas fa-search fa-fw"></i>
                        </a>
                        <a href="#" class="search-button search-clear" id="search-clear-mobile" title="Clear">
                            <i class="fas fa-times-circle fa-fw"></i>
                        </a>
                        <span class="search-button search-loading" id="search-loading-mobile">
                            <i class="fas fa-spinner fa-fw fa-spin"></i>
                        </span>
                    </div>
                    <a href="#" class="search-cancel" id="search-cancel-mobile">
                        Cancel
                    </a>
                </div><a class="menu-item" href="/" title="Blog Homepage">Home</a><a class="menu-item" href="https://alphabravo.io" title="AlphaBravo Website" rel="noopener noreffer" target="_blank">AB Website</a><a class="menu-item" href="/posts/" title="">Posts</a><a class="menu-item" href="https://github.com/AlphaBravoCompany" title="" rel="noopener noreffer" target="_blank"><i class='fab fa-github fa-fw'></i></a><a class="menu-item" href="https://linkedin.com/company/alphabravogov/" title="" rel="noopener noreffer" target="_blank"><i class='fab fa-linkedin fa-fw'></i></a><div class="menu-item"><a href="/index.xml" title="RSS"><i class="fas fa-rss fa-fw" title="RSS"></i> </a>
                <span>&nbsp;|&nbsp;</span><a href="javascript:void(0);" class="theme-switch" title="Switch Theme">
                    <i class="fas fa-adjust fa-fw"></i>
                </a>
            </div></div>
    </div>
</header><div class="search-dropdown desktop">
    <div id="search-dropdown-desktop"></div>
</div>
<div class="search-dropdown mobile">
    <div id="search-dropdown-mobile"></div>
</div><main class="main">
                <div class="container"><div class="toc" id="toc-auto">
            <h2 class="toc-title">Contents</h2>
            <div class="toc-content" id="toc-content-auto"></div>
        </div><article class="page single" data-toc="disable"><div class="featured-image"><img
        class="lazyload"
        src="/svg/loading.min.svg"
        data-src="/assets/2021/12/bulk-delete-cf-full.png"
        data-srcset="/assets/2021/12/bulk-delete-cf-full.png, /assets/2021/12/bulk-delete-cf-full.png 1.5x, /assets/2021/12/bulk-delete-cf-full.png 2x"
        data-sizes="auto"
        alt="/assets/2021/12/bulk-delete-cf-full.png"
        title="Cloudflare doesn&#39;t let you bulk delete in the UI. In this blog, we show you how to use Python script to bulk delete DNS records in Cloudflare." /></div><div class="single-card" data-image="true"><h2 class="single-title animated flipInX">Bulk Delete Cloudflare DNS Records</h2><div class="post-meta">
                <div class="post-meta-line"><span class="post-author"><a href="/" title="Author" rel=" author" class="author"><i class="fas fa-user-circle fa-fw"></i>Mike 'MJ' Johnson</a></span></div>
                <div class="post-meta-line"><span><i class="far fa-calendar-alt fa-fw"></i>&nbsp;<time datetime="2021-12-23">2021-12-23</time></span>&nbsp;<span><i class="fas fa-pencil-alt fa-fw"></i>&nbsp;551 words</span>&nbsp;
                    <span><i class="far fa-clock fa-fw"></i>&nbsp;3 minutes</span>&nbsp;</div>
            </div>
            
            <hr><div class="details toc" id="toc-static"  data-kept="">
                    <div class="details-summary toc-title">
                        <span>Contents</span>
                        <span><i class="details-icon fas fa-angle-right"></i></span>
                    </div>
                    <div class="details-content toc-content" id="toc-content-static"><nav id="TableOfContents">
  <ul>
    <li><a href="#the-bulk-delete-script">The Bulk Delete Script</a></li>
    <li><a href="#running-the-script">Running The Script</a></li>
    <li><a href="#closing">Closing</a></li>
  </ul>
</nav></div>
                </div><div class="content" id="content"><p><a href="https://www.cloudflare.com/" target="_blank" rel="noopener noreffer">Cloudflare</a> is a powerful platform that can help with numerous aspects of managing and securing your infrastructure. We will cover some of the other features in future blogs, but I highly recommend that you look into how Cloudflare can help you or your organization.</p>
<p>In this blog we will discuss a mildly annoying feature of Cloudflare.</p>
<p><strong>You can&rsquo;t easily delete DNS records in bulk.</strong></p>
<p>We rely on Cloudflare for our DNS record management. It allows you to protect the actual source IP behind the Cloudflare proxy network and enables DDOS and other protection (enabling the proxy is optional).</p>
<p>We also use Cloudflare for many trainings, demos and general testing. Often, we create lots of records manually for demonstration purposes, but when it comes time to delete them, you have to delete them. One&hellip;. At&hellip;. A&hellip;. Time.</p>
<p>Luckily, we can leverage a simple python script to delete the records in bulk.</p>
<h2 id="the-bulk-delete-script">The Bulk Delete Script</h2>
<div class="details admonition warning open">
        <div class="details-summary admonition-title">
            <i class="icon fas fa-exclamation-triangle fa-fw"></i>WARNING<i class="details-icon fas fa-angle-right fa-fw"></i>
        </div>
        <div class="details-content">
            <div class="admonition-content"><p>Bulk deleting DNS records is generally NOT advised. Cloudflare likely does not allow for it in the UI because you could seriously mess up your production infrastructure by bulk deleting records you shouldn&rsquo;t. Make CERTAIN that you intend to delete ALL records in a Zone. Use this script at your own risk.</p>
<p>YOU HAVE BEEN WARNED.</p>
</div>
        </div>
    </div>
<p>Now that you have read the above warning, let&rsquo;s look at the script.</p>
<p>The <a href="https://www.python.org/" target="_blank" rel="noopener noreffer">Python</a> script has a few components:</p>
<ul>
<li><code>zoneid</code>: This field indicates the ID of the DNS zone you want to delete records from. You can get zone ID from Overview page on the bottom right section.</li>
<li><code>bearer_token</code>: This is an API key from your Cloudflare interface that allows you to modify DNS records. More information on creating this <a href="https://developers.cloudflare.com/api/tokens/create" target="_blank" rel="noopener noreffer">here</a></li>
<li>Fetch Records: This section queries the specified DNS Zone for records</li>
<li>Delete Records: This section actually deletes the record discovered in the Fetch section</li>
</ul>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-python" data-lang="python"><span class="kn">import</span> <span class="nn">json</span>
<span class="kn">import</span> <span class="nn">requests</span>

<span class="c1"># You can get zone ID from Overview page on the bottom right section</span>
<span class="n">zoneid</span> <span class="o">=</span> <span class="s2">&#34;YOUR_ZONE_ID&#34;</span>

<span class="c1"># You need to generate api token from My Profile &gt; API Token with Edit Zone permission</span>
<span class="n">bearer_token</span> <span class="o">=</span> <span class="s2">&#34;YOUR_BEARER_TOKEN&#34;</span>

<span class="k">if</span> <span class="nb">input</span><span class="p">(</span><span class="s2">&#34;Are you sure you want to delete ALL DNS records in this zone? (y/n)&#34;</span><span class="p">)</span> <span class="o">!=</span> <span class="s2">&#34;y&#34;</span><span class="p">:</span>
    <span class="n">exit</span><span class="p">()</span>


<span class="c1"># Fetch dns records from CloudFlare</span>
<span class="n">record_rq</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&#34;https://api.cloudflare.com/client/v4/zones/&#34;</span><span class="o">+</span> <span class="n">zoneid</span> <span class="o">+</span><span class="s2">&#34;/dns_records&#34;</span><span class="p">,</span> <span class="n">headers</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&#34;Content-Type&#34;</span><span class="p">:</span> <span class="s2">&#34;application/json&#34;</span><span class="p">,</span> <span class="s2">&#34;Authorization&#34;</span><span class="p">:</span> <span class="s2">&#34;Bearer &#34;</span> <span class="o">+</span> <span class="n">bearer_token</span><span class="p">})</span>
<span class="n">data</span> <span class="o">=</span> <span class="n">record_rq</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
<span class="k">if</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;success&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&#34;Failed to fetch dns record:&#34;</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;errors&#39;</span><span class="p">])</span>
    <span class="n">quit</span><span class="p">()</span>

<span class="c1"># Delete dns records</span>
<span class="k">for</span> <span class="n">record</span> <span class="ow">in</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;result&#39;</span><span class="p">]:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&#34;Deleting:&#34;</span><span class="p">,</span> <span class="n">record</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">])</span>
    <span class="n">rq</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="s2">&#34;https://api.cloudflare.com/client/v4/zones/&#34;</span><span class="o">+</span> <span class="n">zoneid</span> <span class="o">+</span><span class="s2">&#34;/dns_records/&#34;</span> <span class="o">+</span> <span class="n">record</span><span class="p">[</span><span class="s1">&#39;id&#39;</span><span class="p">],</span> <span class="n">headers</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&#34;Content-Type&#34;</span><span class="p">:</span> <span class="s2">&#34;application/json&#34;</span><span class="p">,</span> <span class="s2">&#34;Authorization&#34;</span><span class="p">:</span> <span class="s2">&#34;Bearer &#34;</span> <span class="o">+</span> <span class="n">bearer_token</span><span class="p">})</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">rq</span><span class="o">.</span><span class="n">status_code</span><span class="p">,</span> <span class="s2">&#34;</span><span class="se">\n</span><span class="s2">&#34;</span><span class="p">)</span>
</code></pre></div><h2 id="running-the-script">Running The Script</h2>
<ol>
<li>Create a new file on a system that has <code>python3</code> installed.</li>
</ol>
<p>On a Mac or Linux system:</p>
<pre tabindex="0"><code>vi cloudflare-bulk-delete-dns.py
</code></pre><ol start="2">
<li>
<p>Past the contents from the above script into that file. Make sure you update the <code>zoneid</code> and <code>bearer_token</code> fields with your own specific information.</p>
</li>
<li>
<p>Run the script with the following command <em>after you have read the above warning</em>.</p>
</li>
</ol>
<pre tabindex="0"><code>python3 cloudflare-bulk-delete-dns.py
</code></pre><ol start="4">
<li>Wait for the script to delete all DNS records in that zone.</li>
</ol>
<h2 id="closing">Closing</h2>
<p>Hopefully this script saves you some time in the future when cleaning up DNS records.</p>
<p>If you want help implementing Cloudflare DNS or other features for your enterprise, please reach out to us at <a href="mailto:info@alphbravo.io" rel="">info@alphbravo.io</a></p>
<p>That&rsquo;s all for now!</p>
<hr>
<p><em>The AB Engineering Team</em></p>
<p><strong>Website:</strong> <a href="https://alphabravo.io" target="_blank" rel="noopener noreffer">https://alphabravo.io</a></p>
<p><strong>Contact Us:</strong> <a href="https://alphabravo.io/contact-us" target="_blank" rel="noopener noreffer">https://alphabravo.io/contact-us</a></p></div><div class="post-footer" id="post-footer">
    <div class="post-info"><div class="post-info-tag"><span><a href="/tags/cloudflare/">cloudflare</a>
                </span><span><a href="/tags/dns/">dns</a>
                </span></div><div class="post-info-line"><div class="post-info-mod">
                <span>Updated on 2021-12-23</span>
            </div><div class="post-info-mod"></div>
        </div></div><div class="post-nav"><a href="/posts/2021/zero-to-hero-working-with-multiple-kubeconfig/" class="prev" rel="prev" title="Zero To Hero: Working With Multiple Kubeconfig Files"><i class="fas fa-angle-left fa-fw"></i>Previous Post</a></div></div>
</div></article></div>
            </main>
            <footer class="footer"><div class="footer-container"><div class="footer-line">AlphaBravo</div><div class="footer-line" itemscope itemtype="http://schema.org/CreativeWork"><i class="far fa-copyright fa-fw"></i><span itemprop="copyrightYear">2021</span><span class="author" itemprop="copyrightHolder">&nbsp;<a href="/"></a></span></div>
</div>
</footer>
        </div>

        <div id="fixed-buttons"><a href="#" id="back-to-top" class="fixed-button" title="Back to Top">
                <i class="fas fa-chevron-up fa-fw"></i>
            </a></div><link rel="stylesheet" href="/lib/fontawesome-free/all.min.css"><link rel="stylesheet" href="/lib/animate/animate.min.css"><link rel="stylesheet" href="/lib/lightgallery/lightgallery.min.css"><link rel="stylesheet" href="/lib/cookieconsent/cookieconsent.min.css"><script src="/lib/autocomplete/autocomplete.min.js"></script><script src="/lib/lunr/lunr.min.js"></script><script src="/lib/lazysizes/lazysizes.min.js"></script><script src="/lib/typeit/typeit.min.js"></script><script src="/lib/lightgallery/lightgallery.min.js"></script><script src="/lib/lightgallery/lg-thumbnail.min.js"></script><script src="/lib/lightgallery/lg-zoom.min.js"></script><script src="/lib/clipboard/clipboard.min.js"></script><script src="/lib/cookieconsent/cookieconsent.min.js"></script><script>window.config={"code":{"copyTitle":"Copy to clipboard","maxShownLines":50},"comment":{},"cookieconsent":{"content":{"dismiss":"Ok","link":"https://alphabravo.io","message":"We use cookies and open-source, privacy-respecting analytics technologies to improve your browsing experience on our website, to analyze our website traffic, and to understand where our visitors are coming from."},"enable":true,"palette":{"button":{"background":"#f0f0f0"},"popup":{"background":"#1aa3ff"}},"theme":"edgeless"},"data":{"id-1":"Engineering Blog","id-2":"Engineering Blog"},"lightGallery":{"actualSize":false,"exThumbImage":"data-thumbnail","hideBarsDelay":2000,"selector":".lightgallery","speed":400,"thumbContHeight":80,"thumbWidth":80,"thumbnail":true},"search":{"highlightTag":"em","lunrIndexURL":"/index.json","maxResultLength":10,"noResultsFound":"No results found","snippetLength":30,"type":"lunr"},"typeit":{"cursorChar":null,"cursorSpeed":null,"data":{"id-1":["id-1"],"id-2":["id-2"]},"duration":null,"speed":null}};</script><script src="/js/theme.min.js"></script><script data-goatcounter="https://stats.alphabravo.io/count" async src="//stats.alphabravo.io/count.js"></script></body></html>
